#ifndef CAN_H_
#define CAN_H_

/******************************************************************************
* Include files
******************************************************************************/


/******************************************************************************
* Types
******************************************************************************/

typedef union{
	uint8_t BYTES[8];
	struct {
		uint8_t Operab;
		uint8_t SpeedAct;
		uint8_t SpeedRef;
		uint8_t ReqTorque;
		uint8_t StBrakes : 1;
		uint8_t StControl : 1;
		uint8_t ND4 : 6;
		uint8_t ND5;
		uint8_t ND6;
		uint8_t ND7;
	} message;
} stecc_message_t;

typedef union{
	uint8_t BYTES[8];
	struct {
		uint8_t TurnOff : 1;
		uint8_t ClutchSt : 1;
		uint8_t ND0 : 6;
		uint8_t ND1;
		uint8_t ND2;
		uint8_t ND3;
		uint8_t ND4;
		uint8_t ND5;
		uint8_t ND6;
		uint8_t ND7;
	} message;
} cmdecc_message_t;

/******************************************************************************
* External Variables
******************************************************************************/

/******************************************************************************
* Constants
******************************************************************************/


/******************************************************************************
* Macros
******************************************************************************/

#define TRUE	1
#define FALSE	0

#define MSG_CMD_ECC 0  //Rx message
#define MSG_ST_ECC  1  //Tx message

/******************************************************************************
* Global Function Declarations
******************************************************************************/
void CAN_Init (void);
void CAN_SendMob1 (const void* DataPtr);
void CAN_ReceiveEnableMob0(void);

#endif /* CAN_H_ */