/*
 * can_adc.c
 *
 * Created: 2016. 09. 07. 9:20:21
 * Author : AradiSzilard
 */ 

/******************************************************************************
* Include files
******************************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>

#include "lcd.h"
#include "timer.h"
#include "adc.h"
#include "can.h"

/******************************************************************************
* Macros
******************************************************************************/

/******************************************************************************
* Constants
******************************************************************************/
const uint8_t ECCTorqFact=2;

/******************************************************************************
* Global Variables
******************************************************************************/
uint16_t TorqDem;
uint8_t ReceiveData[8];
stecc_message_t StEccMsg;

/******************************************************************************
* External Variables
******************************************************************************/
extern volatile uint16_t ADCresult;
extern volatile uint8_t ADC_Ready;
extern cmdecc_message_t CmdEccMsg;
extern volatile uint8_t Task_1000ms,Task_100ms;
/******************************************************************************
* Local Function Declarations
******************************************************************************/

/******************************************************************************
* Local Function Definitions
******************************************************************************/

int main (void)
{
	char s[16];
	
	lcdinit();
	CAN_Init ();
	CAN_ReceiveEnableMob0 ();
	ADC_Init();
	TIMER0_Init();
	
	TorqDem=150; //Nm
	StEccMsg.message.SpeedRef=130;
	StEccMsg.message.SpeedAct=0;
	StEccMsg.message.Operab=1;
	StEccMsg.message.ReqTorque=TorqDem/ECCTorqFact;
	StEccMsg.message.StBrakes=0;
	StEccMsg.message.StControl=1;

	sei();

	while (1)
	{
		if (Task_1000ms)
		{
			lcd_set_address(0);
			if(CmdEccMsg.message.TurnOff)
			  lcdreir("ECC OFF");
			else
			  lcdreir("ECC ON ");
			lcd_set_address(40);
			sprintf(s,"0x%x",CmdEccMsg.BYTES[0]);
			lcdreir(s);
			Task_1000ms = FALSE;
		}
		if (Task_100ms)
		{
			StEccMsg.message.SpeedAct=(uint8_t)(ADCresult>>2);
			CAN_SendMob1(StEccMsg.BYTES);
			Task_100ms = FALSE;
		}
	}
}